
-- The actual math for determining "How Many Days" needs to convert dates to Julian Date
-- Function below determines the Julian Date for the users event
local function julianDate(year, month, day)
	a=math.floor((14-month)/12)
	b=year+4800-a
	c=month+12*a-3
	d=math.floor(((153*c+2)/5))
	e=math.floor((b/4))
	f=math.floor((b/100))
	g=math.floor((b/400))
	z = day + d + 365*b + e - f + g - 32045
	return z
end


-- Taking the Julian Date for the event (result of the function above), and comparing it to "today"
-- This yields the actual "How Many Days", and displays it
function updateCountdown(e)
	local timeTable = os.date("*t")
	local today = julianDate(timeTable.year, timeTable.month, timeTable.day)
	local eDay = julianDate(eventYear, eventMonth, eventDay)	
	if eDay - today == 1 then
		countDisplay.text = "TOMORROW IS"
		eventDisplay.text = (string.upper(eventName).."!!!")
	elseif eDay - today == 0 then
		countDisplay.text = "TODAY IS"
		eventDisplay.text = (string.upper(eventName).."!!!")
	elseif eDay - today == -1 then
		today = ((eDay - today)) * -1
		countDisplay.text = ("It's Been "..today.." Day Since")
		eventDisplay.text = eventName
	elseif eDay - today < 0 then
		today = ((eDay - today)) * -1
		countDisplay.text = ("It's Been "..today.." Days Since")
		eventDisplay.text = eventName
	else
		today = (eDay - today)
		countDisplay.text = (today.." Days Until")
		eventDisplay.text = eventName
	end
end


-- And to make it feel fresh and active... 
-- Rotating the hands of the clock with the Hour/Minute/Seconds
function updateClock(e)
	local timeTable = os.date("*t")
	hourHand.rotation = timeTable.hour * 30 + (timeTable.min * 0.5)
	minHand.rotation = timeTable.min * 6
	secHand.rotation = timeTable.sec * 6
	timeDisplay.text = os.date("%I:%M:%S")
	dateDisplay.text = os.date("%m/%d/%Y")
end


-- Display a "Here's how it works" message, that they can then dismiss if they so choose:
function instructionBox(event)
	if "clicked" == event.action then
        local i = event.index
        if 1 == i then
            -- Do nothing; dialog will simply dismiss
        elseif 2 == i then
            appSettings.instructions = "off"  -- If they click dont show... then dont show it EVER AGAIN!
            saveData()
        end
    end
end


-- Call all of the above things upon the loading of an HMD Countdown screen

-- First, load thier saved data:
loadData()
-- Then do all of the date/time math... Delays simply ensure things are getting done in order
timer.performWithDelay(500, updateClock, 0)
timer.performWithDelay(1000, updateCountdown, 0)
-- Check to see if they have dismissed the instructions or not... if not, display a native alert
Runtime:addEventListener( "key", onKeyEvent )
if appSettings.instructions == "on" then
	alert = native.showAlert( "Instructions", "Tap the date to change the day of your event, tap the countdown to change your event's name, or tap the clock to change your theme. Swipe left and right to change events.", { "OK", "Don't Show" }, instructionBox )
end